% this function is the general deployment function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc
clear

%% General Parameters
T_f = 600;  % consistent with simulation final time
% to simulation time step which is directly specified in Simulink) 
dt = 0.01; % s, it is noted that this is the simulation step

%% Configurate WEC-Sim
% Initialize WEC-Sim
SimFileName = 'Sim_DRL_LUPA_ver4_Nonlinear';
Hs = 0.21;
Tp = 3.09;
Ki = 0;
Kp = 4206.83;
run('wecSimInputFile');
clear simu waves body cable pto constraint ptoSim mooring 
runWecSimCML = 1;
run('initializeWecSim');

%% Run model
tic
sim('Sim_DRL_LUPA_ver4_Nonlinear')
toc

%% Plot the results
figure
plot(z_vec.time,z_vec.signals.values,'linewidth',1.5)
xlabel('Time(s)')
ylabel('Displacement (m)')
set(gca,'Fontsize',18,'FontWeight','bold')
grid on
figure
plot(v_vec.time,v_vec.signals.values,'linewidth',1.5)
xlabel('Time(s)')
ylabel('Vel (m/s)')
set(gca,'Fontsize',18,'FontWeight','bold')
grid on

Pow = -squeeze(F_PTO.signals.values).*v_vec.signals.values;
Ene = cumsum(Pow)*dt;
figure
plot(F_PTO.time,Ene,'linewidth',1.5)
xlabel('Time(s)')
ylabel('Energy (J)')
set(gca,'Fontsize',18,'FontWeight','bold')
grid on

figure
plot(F_PTO.time,F_PTO.signals.values,'linewidth',1.5)
xlabel('Time(s)')
ylabel('Energy (J)')
set(gca,'Fontsize',18,'FontWeight','bold')
grid on

























